<?php

class UserAccount
{
    const OUTPUT_TEMPLATE = "Account Holder: %s\nContact Details: %s\nCard Details: %s\nLogin Details: %s\nAccount Notes:\n%s";
    
    protected $_faker;
    
    public function __construct()
    {
        $this->_faker = Faker\Factory::create('en_AU');
        $this->_faker->addProvider(new \Faker\Provider\AccountHolder($this->_faker));
        $this->_faker->addProvider(new \Faker\Provider\AccountPayment($this->_faker));
    }
    
    public function __call($name, $arguments) {
        if (!method_exists($this, $name)) {
            return $this->_faker->$name($arguments);
        }
    }
    
    public function accountNotes() {
        return $this->_faker->paragraphs(2);
    }

    public function lastLogin() {
        return sprintf(
            "%s - %s", 
            $this->_faker->countryCode, 
            $this->_faker->dateTimeBetween('-1 week', 'now')->format('Y-m-d H:i:s')
        );
    }

    public function notes() {
        $accountNotes = "";
        foreach ($this->accountNotes($this->_faker) as $note) {
            $accountNotes .= $note;
        }
        return $accountNotes;
    }
    
    public function contactDetails()
    {
        return sprintf("%s - %s", $this->_faker->email, $this->_faker->phoneNumber);
    }
}