#!/usr/bin/env php
<?php
use Everyman\Neo4j\Client,
	Everyman\Neo4j\Index\NodeIndex,
	Everyman\Neo4j\Relationship,
	Everyman\Neo4j\Node;

// Note : Change the values below to load more from the database.
define('USER_LIMIT', 20);
define('LIKES_LIMIT', 800);

die("Please, edit the code and point the path below to neo4jphp/examples/ directory.\n Then, remove this die(); \n\n");
require 'YOUR_PATH_HERE'.'/neo4jphp-master/examples/example_bootstrap.php';

$client = new Client();
$fp = fopen('usersha1-artmbid-artname-plays.tsv', 'r');

$names = array('Arthur', 'Bertha', 'Cesar', 'Dolly', 'Edouard', 'Fran', 'Gustav', 'Hortense', 'Isidore', 'Josephine', 'Kyle', 'Lili', 'Marco', 'Nana', 'Omar', 'Paloma', 'Rene', 'Sally', 'Teddy', 'Vicky', 'Wilfred', 'Xavier', 'Zoe');

global $classes;
$users = array();
$artists = array();

$begin_time = microtime(true);
$likes = 0;
$total = 0;

while($row = fgets($fp)) {
    list($user, $ignore, $artist, $ignore) = explode("\t", $row);
    $total++;
    
    if (!isset($users[$user])) {
        $cycle = ceil( count($users) / count($names));
        $users[$user] = $client->makeNode()->setProperty('user', $names[count($users) % count($names)]." $cycle")->save();
    }

    if ($likes < LIKES_LIMIT) {
        if (!isset($artists[$artist])) {
            $artists[$artist] = $client->makeNode()->setProperty('name', $artist)->save();
        }

        $users[$user]->relateTo($artists[$artist], 'LIKES')->save();
        $likes++;
    }

    if (count($users) > USER_LIMIT) {
        break 1;
    }
}

$end_time = microtime(true);

print "Executed in ".number_format(($end_time - $begin_time) * 1000, 2)." ms\n";
print $total." read\n";
print $likes." likes\n";
print count($users)." users\n";
print count($artists)." artists\n";

?>