#!/usr/bin/env php
<?php
use Everyman\Neo4j\Client,
    Everyman\Neo4j\Index\NodeIndex,
    Everyman\Neo4j\Relationship,
    Everyman\Neo4j\Node;

die("Please, edit the code and point the path below to neo4jphp/examples/ directory.\n Then, remove this die(); \n\n");
require 'YOUR_PATH_HERE'.'/neo4jphp-master/examples/example_bootstrap.php';

$client = new Client();

global $classes;
$users = array();

$debut = microtime(true);
$max_likes = 400;
$max_users = 20;

$input = array(
     "Gustav" => array("metallica", "queen", "tool", "children of bodom", "paramore"),
     "Dolly" => array("children of bodom", "tool", "stone template pilots"),
     "Hortense" => array("metallica", "a-ha"),
);

$likes = 0;
$total = 0;

foreach($input as $user => $as) {
    if (!isset($users[$user])) {
        $cycle = ceil( count($users) / count($names));
        $users[$user] = $client->makeNode()->setProperty('user', $names[count($users) % count($names)]." $cycle")->save();
    }

    foreach($as as $artist) {
        $total++;

        if (!isset($artists[$artist])) {
            $artists[$artist] = $client->makeNode()->setProperty('name', $artist)->save();
        }
    
        print "$user -> $artist\n";
    
        $users[$user]->relateTo($artists[$artist], 'LIKES')->save();
    }
}

$fin = microtime(true);

print number_format(($fin - $debut) * 1000, 2)." ms\n";
print $total." read\n";
print $likes." likes\n";
print count($users)." users\n";
print count($artists)." artists\n";

?>